//
//	File:			VisualInfo.java
//	Author:		Krzysztof Langner
//	Date:			1997/04/28
//


import java.util.*;


class VisualInfo 
{
   


//===========================================================================
// Initialization member functions
	public VisualInfo(String info)
	{
		info=info.trim();
      info_from_server = info;
//debug(info);
		m_tokenizer = new StringTokenizer(info,"() ", true);
		m_objects = new Vector(41);
	}

	//---------------------------------------------------------------------------
	// This function parses visual information from the server

	public void parse()
	{
		String token = null;
		ObjectInfo	objInfo;

      int COUNT=0;
		try
		{
			// First is '('
			m_tokenizer.nextToken();	
			// then we should find see
			if( m_tokenizer.nextToken().compareTo("see") != 0 )	
				return;

			// now ' ' followed by time and ' '
			m_tokenizer.nextToken();	
			m_time = Integer.parseInt( m_tokenizer.nextToken() );

         if (Krislet.server_time == m_time) Krislet.server_time = -1;
         else Krislet.server_time = m_time;

			m_tokenizer.nextToken();	

			// then we should fine '('
			token = m_tokenizer.nextToken();

         boolean isBall = false;


			while(token.compareTo("(") == 0)
			{
            COUNT++;
				// we have another object so go on
				// and get its name.
				objInfo = createNewObject();

            if (objInfo instanceof BallInfo) isBall=true;
            else isBall=false;

				m_objects.addElement(objInfo);
				
				token = m_tokenizer.nextToken();
				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0)
						token = m_tokenizer.nextToken();
					continue;
				}

				// get distance
				token = m_tokenizer.nextToken();
				objInfo.m_distance = Float.valueOf(token).floatValue();

            //updatni info o lopte v Brain
            //if (isBall) Brain.staticBall.m_distance = objInfo.m_distance;

				token = m_tokenizer.nextToken();
				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0)
						token = m_tokenizer.nextToken();
					continue;
				}

				// get direction
				objInfo.m_direction = Float.valueOf(m_tokenizer.nextToken()).floatValue();

            //updatni info o lopte v Brain
            //if (isBall) Brain.staticBall.m_direction = objInfo.m_direction;

				token = m_tokenizer.nextToken();
				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0)
						token = m_tokenizer.nextToken();
					continue;
				}

				// get distance change
				objInfo.m_distChange = Float.valueOf(m_tokenizer.nextToken()).floatValue();

            //updatni info o lopte v Brain
            //if (isBall) Brain.staticBall.m_distChange = objInfo.m_distChange;

				token = m_tokenizer.nextToken();
				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0)
						token = m_tokenizer.nextToken();
					continue;
				}

				// get direction change
				objInfo.m_dirChange = Float.valueOf(m_tokenizer.nextToken()).floatValue();

            //updatni info o lopte v Brain
            //if (isBall) Brain.staticBall.m_dirChange = objInfo.m_dirChange;

				token = m_tokenizer.nextToken();
				token = m_tokenizer.nextToken();
				if(token.compareTo(" ") == 0)
					token = m_tokenizer.nextToken();
			}
		}
		catch(Exception e)
		{
			System.out.println("Error parsing see information: COUNT="+COUNT+" MESSAGE:"+e.getMessage());
			System.out.println("TOKEN="+token);
			while( m_tokenizer.hasMoreTokens() )
				System.out.print(m_tokenizer.nextToken());
         m_objects.clear();
			System.out.println("");
		}
	}



//===========================================================================
// Private implementaions

	//---------------------------------------------------------------------------
	// This function creates new information object
	private ObjectInfo createNewObject()
	{
		String			token;
		ObjectInfo	objInfo = null;
		
			// bypass first "("
			m_tokenizer.nextToken();
			token = m_tokenizer.nextToken();
			if(token.compareTo("player") == 0)
			{
				String team = new String();
				int uniformNumber = 0;
				token = m_tokenizer.nextToken();	// space
				if(token.compareTo(" ") == 0)
				{
					team = m_tokenizer.nextToken();	// teamname
					token = m_tokenizer.nextToken();	// space
					if(token.compareTo(" ") == 0)
						uniformNumber = Integer.parseInt(m_tokenizer.nextToken());	// uniform number
				}
				objInfo = new PlayerInfo(team,uniformNumber);
			}
			else if(token.compareTo("goal") == 0)
			{
				token = m_tokenizer.nextToken();	// space
				if(token.compareTo(" ") == 0)
					token = m_tokenizer.nextToken();	// side
				objInfo = new GoalInfo(token.charAt(0));
			}
			else if(token.compareTo("ball") == 0)
			{
				objInfo = new BallInfo();
			}
			else if(token.compareTo("flag") == 0)
			{
				/*char type = ' ';
				char posHoriz, posVert;
				token = m_tokenizer.nextToken();	// space
				token = m_tokenizer.nextToken();	// p or [l|c|r]
				if( token.compareTo("p") == 0 )
				{
					type = token.charAt(0);
					token = m_tokenizer.nextToken();	// space
					token = m_tokenizer.nextToken();	// [l|r]
				}
				posHoriz = token.charAt(0);
				token = m_tokenizer.nextToken();	// space
				token = m_tokenizer.nextToken();	// [t|c|b]
				posVert = token.charAt(0);
				objInfo = new FlagInfo(type, posHoriz, posVert);*/

            //space
            token=m_tokenizer.nextToken();

            String type="";
            token="";
            while(token.compareTo(")") != 0)
            {
               type+=token;
				   token = m_tokenizer.nextToken();
            }
            objInfo = new FlagInfo(type);
			}
			else if(token.compareTo("line") == 0)
			{
				token = m_tokenizer.nextToken();	// space
				token = m_tokenizer.nextToken();	// [l|r|t|b]
				objInfo = new LineInfo(token.charAt(0));
			}
			else if(token.compareTo("Player") == 0)
			{
				objInfo = new PlayerInfo();
			}
			else if(token.compareTo("Goal") == 0)
			{
				objInfo = new GoalInfo();
			}
			else if(token.compareTo("Ball") == 0)
			{
				objInfo = new BallInfo();
			}
			else if(token.compareTo("Flag") == 0)
			{
				objInfo = new FlagInfo();
			}
			else if(token.compareTo("Line") == 0)
			{
				objInfo = new LineInfo();
			}

			// Now we should find ")" token
			while(token.compareTo(")") != 0)
				token = m_tokenizer.nextToken();

			return objInfo;
	}

   public String toString()
   {
      return(info_from_server);
   }


//===========================================================================
// Public members
	int				m_time;
	Vector		m_objects;


//===========================================================================
// Private members
	private StringTokenizer	m_tokenizer;


   private String info_from_server;

}

