// BaseAgent.h: interface for the CBaseAgent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASEAGENT_H__7FCEA561_5114_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_BASEAGENT_H__7FCEA561_5114_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Agentsock.h"
#include "TPerception.h"
//#include "PlayerDoc.h"

class CPlayerDoc;

/*-----------------------------------------------------------------------------
Class   : CBaseAgent
Date    : 30.10.97
-------------------------------------------------------------------------------
Base Class: CObject

Description: base class for all agents
-----------------------------------------------------------------------------*/
class CBaseAgent : public CAgentSocket
{
	public:

		CBaseAgent(void);
		virtual ~CBaseAgent();
		BOOL	ConnectAgent(LPCTSTR lpszTeam, LPCTSTR lpszServer, UINT nPort,BOOL bGoalie);
		void	DisconnectAgent(void);

		// communication functions
		virtual void OnReceive(int nErrorCode);
		void SendMsg(CString& strText);
	
		// overridables
		virtual void OnCreatedSocket();
		virtual void OnSentMessage(LPCTSTR message) {};
		virtual void OnReceivedMessage(LPCTSTR message);
		
		virtual void OnErrorCreatingSocket() {};
		virtual void OnErrorSendingMessage() {};
		virtual void OnErrorReceivingMessage() {};

		virtual void OnChangedView(int mode, int quality) {};

		// the agents actions
		void	Move(int x, int y);
		void	Turn(int iMoment);
		void	Dash(int iPower);
		void	Kick(int iPower, int iDirection);
		void	Catch(int iDir);
		void	Say(CString csMessage);
		void	ChangeView(int iWidth, int iQuality);
		void	SenseBody();
		void    SendBye();

		void  MoveRel(int x);	// moves relative to the current position

		// attribute fuctions
		BOOL	IsConnected() { return m_bConnected; };
		int		GetSide() { return m_iSide; };
		void	SetSide(int side) { m_iSide = side; };
		int		GetNumber() { return m_iNumber; };
		void	SetNumber(int number) { m_iNumber = number; };
		TPerception* GetPerception() { return &m_pPerception; }
		void	SetDoc(CPlayerDoc *p) { m_pDoc = p; }
		TPerception		m_pPerception;

		int		GetAutoPlay() { return m_iAutoPlay; };
		int		SetAutoPlay(int aNewMode);
		void	AutoPlay();

		//TVector GetBallInterceptPos();
		int     GetAvoidAngle(TPlayer* pAgent, TVector DestPos);
		TVector GetBallInterceptPos(TPlayer* pAgent);
		TVector GetDefendPos(TPlayer* pAgent);
		int     GetFormationPos(TVector &defpos);
		TPlayer* GetNearestOpponent(TPlayer* pAgent);
		int     RunTo(TVector DestPos, int Backw = 0);
		int     KickTo(TDirection DestDir);
		int     KickRel(int Power, TDirection Dir);
		int     KickRel0(int Power0, TDirection Dir0);
		int     TurnBallTo(TDirection DestDir, int Safe = 1);
		void	AutoPlay1();
		void	AutoPlay2();
		BOOL IsBallCaught();
		BOOL CanCatchBall(double dPlayerX,double dPlayerY,double dBallX,double dBallY);
		void	AutoPlay3();
		void	AutoPlay4();

		int		AbsTurn(int aNewAbsDir);
	
	protected:
		BOOL m_bGoalie;

		int				m_iSide;		// side on which playing
		int				m_iNumber;	// number of the player
		int				m_iPositionX;	// position of the agent x coordinate
		int				m_iPositionY;	// position of the agent y coordinate
		int				m_iDirection;	// view direction of the agent

		int				m_iAutoPlay;

		BOOL			m_bConnected;	// true, if the agent is currently connected
		CPlayerDoc		*m_pDoc;

		CString	   m_strTeam;	// name of the team the player is in
};

#endif // !defined(AFX_BASEAGENT_H__7FCEA561_5114_11D1_B242_0000C09B5CBE__INCLUDED_)
