// Player.h : main header file for the PLAYER application
//

#if !defined(AFX_PLAYER_H__32FBAB85_B331_11D3_A29A_0020AFCCD8BB__INCLUDED_)
#define AFX_PLAYER_H__32FBAB85_B331_11D3_A29A_0020AFCCD8BB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#define RAD2DEG	(180.0/PI)
#define DEG2RAD (PI/180.0)
#define Rad2Deg(a) 	((double)(a) * RAD2DEG)
#define Rad2IDeg(a)	(int)(Rad2Deg(a))
#define Deg2Rad(a)	((double)(a) * DEG2RAD)

#define MAX_STAMINA			3500
#define STAMINA_INCREMENT	35
#define PLAYER_SPEED_MAX	1.0
#define PLAYER_DECAY			0.4
#define PLAYER_SIZE			0.3
#define KICKABLE_MARGIN		0.7
#define KICK_POWER_RATE		0.016
#define DASH_POWER_RATE		0.006
#define MAXPOWER                100.0

#define BALL_SPEED_MAX		2.7
#define BALL_DECAY			0.94
#define BALL_SIZE				0.085
#define SEND_STEP				150
#define EFFORT_MIN			0.6
#define CATCHABLE_AREA_L	2.0
#define CATCHABLE_AREA_W	1.0

#define LOW_STAMINA			1000		// point at which it costs effort


#define MY_TEAM				"Motkovia"		// name of my team
#define DEFAULT_SERVER		"localhost"
#define DEFAULT_CHANNEL		6000			// socket channel
#define DEFAULT_MASTERCH	6001			// channel for master mode

/****************************** COLORS *******************************/

#define COLOR_MYTEAM RGB(200, 200, 20)			// yellow
#define COLOR_OTHERTEAM RGB(200, 20, 20)		//	red
#define COLOR_AGENT RGB(20, 200, 20)			// green
#define COLOR_BALL RGB(20, 20, 230)				// blue
#define COLOR_GOAL RGB(0, 0, 0)					// black
#define COLOR_FLAG RGB(200, 200, 200)			// light gray
#define COLOR_LINE RGB(255, 255, 255)			// white
#define COLOR_ANY_OBJECT RGB(40, 40, 40)		// dark gray
#define COLOR_FIELD RGB(10, 100, 10)			// green
#define COLOR_BACK RGB(20, 150, 20)				// green, a little lighter than above
#define COLOR_SKY RGB(30, 30, 150);				// light blue

/****************************** FLAGS *******************************/

#define NO_OF_FLAGS		56
#define CENTER_MARK		0
#define CENTER_TOP		1
#define CENTER_BOTTOM	2
#define GOAL_POST_L		3
#define GOAL_POST_R		5
#define FLAG_OUTSIDE_TL	7
#define FLAG_OUTSIDE_TC	12
#define FLAG_OUTSIDE_TR	13
#define FLAG_OUTSIDE_BL	18
#define FLAG_OUTSIDE_BC	23
#define FLAG_OUTSIDE_BR	24
#define FLAG_OUTSIDE_LT	29
#define FLAG_OUTSIDE_LC	32
#define FLAG_OUTSIDE_LB	33
#define FLAG_OUTSIDE_RT	36
#define FLAG_OUTSIDE_RC	39
#define FLAG_OUTSIDE_RB	40
#define FLAG_PENALTY_L	43
#define FLAG_PENALTY_R	46
#define FLAG_TL			49
#define FLAG_TR			50
#define FLAG_BR			51
#define FLAG_BL			52
#define GOAL_L			53
#define GOAL_R			54
#define TRASH_FLAG		55

#define SIZE_X			120
#define SIZE_Y			80

#define	GW				3.5		// goal width/2
#define FW				52.5		// field width
#define	FH				34			// field height
#define	PW				36			// penalty width
#define	PH				20.16		// penalty height

#define FLAG_POSITIONS_X { 0, 0, 0, -FW, -FW, FW, FW\
				, -10, -20, -30, -40, -50, 0\
				, 10, 20, 30, 40.0, 50\
				, -10, -20, -30, -40.0, -50, 0\
				, 10, 20, 30, 40, 50\
				, -FW-5, -FW-5, -FW-5, -FW-5\
				, -FW-5, -FW-5, -FW-5\
				, FW+5, FW+5, FW+5, FW+5\
				, FW+5, FW+5, FW+5\
				, -PW, -PW, -PW, PW, PW, PW, -FW, FW\
				, FW, -FW, -FW, FW, 0 }

#define FLAG_POSITIONS_Y { 0, FH, -FH, GW, -GW, GW, -GW\
				, FH+5, FH+5, FH+5, FH+5, FH+5, FH+5\
				, FH+5, FH+5, FH+5, FH+5, FH+5\
				, -FH-5,-FH-5,-FH-5,-FH-5,-FH-5,-FH-5\
				,-FH-5,-FH-5,-FH-5,-FH-5,-FH-5\
				, 10, 20, 30, 0\
				,-10,-20,-30.0\
				, 10, 20, 30, 0\
				,-10,-20,-30.0\
				, PH, 0.0,-PH, PH, 0,-PH, FH, FH\
				, -FH, -FH, 0, 0, 0 }

#define DIS_VERSION	1					// version info for serialization
#define PI				3.1415926		// pi
#define D_ZERO_P		0.0000001
#define D_ZERO_N		-0.0000001

#define FIELD_FLAG			1
#define PENALTY_AREA_FLAG	2



#define LEFT_TO_RIGHT	0
#define RIGHT_TO_LEFT	1

#define MAX_PLAYERS 22				// maximum number of players
#define PLAYERS_PER_TEAM 11			// actual number of players per team

#define MAX_NUM_PLAYER 50			// max pocet registrovanych hracov
#define MAX_PERCEPTION_LEN 1024	// maximum length of perception message
#define MAX_SAY_LEN					// maximum length of a say statement

#define NOT_EXISTING -32000	// items not existing in a perception

// playmodes (Left are always odd numbers)
/*#define BEFORE_KICK_OFF		0
#define KICK_OFF_L			1
#define KICK_OFF_R			2
#define KICK_IN_L				3
#define KICK_IN_R				4
#define CORNER_KICK_L		5
#define CORNER_KICK_R		6
#define GOAL_KICK_L			7
#define GOAL_KICK_R			8
#define FREE_KICK_L			9
#define FREE_KICK_R			10
#define PLAY_ON				20
#define HALF_TIME				21
#define TIME_UP				22
#define EXTEND					23
#define FOUL_L					50
#define FOUL_R					60
*/

#define FIELD_FLAG			1
#define PENALTY_AREA_FLAG	2

// for visualizing
#define PLAYERSIZE	6			// radius of the circle representing the player
#define BALLSIZE		4
#define FLAG_SIZE		3

#define MODULE_SIZE 5.0

#define NO_OF_PLAYMODES		17

#define PLAYMODE_STRINGS {"",\
			"before_kick_off",\
			"time_over",\
			"play_on",\
			"kick_off_l",\
			"kick_off_r",\
			"kick_in_l",\
			"kick_in_r",\
			"free_kick_l",\
			"free_kick_r",\
			"corner_kick_l",\
			"corner_kick_r",\
			"goal_kick_l",\
			"goal_kick_r",\
			"goal_l",\
			"goal_r",\
			"drop_ball"}

#define		M_BEFORE_KICK_OFF 1
#define		M_TIME_OVER		2
#define		M_PLAY_ON			3
#define		M_KICK_OFF_L		4
#define		M_KICK_OFF_R		5
#define		M_KICK_IN_L		6
#define		M_KICK_IN_R		7
#define		M_FREE_KICK_L		8
#define		M_FREE_KICK_R		9
#define		M_CORNER_KICK_L	10
#define		M_CORNER_KICK_R	11
#define		M_GOAL_KICK_L		12
#define		M_GOAL_KICK_R		13
#define		M_GOAL_L			14
#define		M_GOAL_R			15
#define		M_DROP_BALL		16
/*
typedef enum _PlayMode {
     PM_Null,
     PM_BeforeKickOff,
	 PM_TimeOver,
     PM_PlayOn,
     PM_KickOff_Left,
     PM_KickOff_Right,
     PM_KickIn_Left,
     PM_KickIn_Right,
	 PM_FreeKick_Left,
	 PM_FreeKick_Right,
	 PM_CornerKick_Left,
	 PM_CornerKick_Right,
	 PM_GoalKick_Left,
	 PM_GoalKick_Right,
	 PM_AfterGoal_Left,
	 PM_AfterGoal_Right,
	 PM_Drop_Ball,
     PM_MAX 
} PlayMode ;
*/

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp:
// See Player.cpp for the implementation of this class
//

class CPlayerApp : public CWinApp
{
public:
	CPlayerApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlayerApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CPlayerApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLAYER_H__32FBAB85_B331_11D3_A29A_0020AFCCD8BB__INCLUDED_)
