// PlayerDoc.cpp : implementation of the CPlayerDoc class
//

#include "stdafx.h"
#include "Player.h"

#include "PlayerDoc.h"
#include "DSetupDlg.h"
#include "BaseAgent.h"
#include "Math.h"
#include "Module.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayerDoc

IMPLEMENT_DYNCREATE(CPlayerDoc, CDocument)

BEGIN_MESSAGE_MAP(CPlayerDoc, CDocument)
	//{{AFX_MSG_MAP(CPlayerDoc)
	ON_COMMAND(ID_CONNECT, OnConnect)
	ON_UPDATE_COMMAND_UI(ID_CONNECT, OnUpdateConnect)
	ON_COMMAND(ID_DISCONNECT, OnDisconnect)
	ON_UPDATE_COMMAND_UI(ID_DISCONNECT, OnUpdateDisconnect)
	ON_COMMAND(ID_GRAPHICS, OnGraphics)
	ON_UPDATE_COMMAND_UI(ID_GRAPHICS, OnUpdateGraphics)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayerDoc construction/destruction

CPlayerDoc::CPlayerDoc()
{
	// TODO: add one-time construction code here
	m_aPlayer.SetDoc(this);
	m_bTryingToConnect = FALSE;
	m_bNoGraphics = FALSE;
	for (int i=0;i<MAX_NUM_PLAYER;i++)
		m_Players[i].Invalidate();

}

CPlayerDoc::~CPlayerDoc()
{
}

BOOL CPlayerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	//m_Modules.AddHead(&);
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CPlayerDoc serialization

void CPlayerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerDoc diagnostics

#ifdef _DEBUG
void CPlayerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPlayerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPlayerDoc commands

void CPlayerDoc::OnConnect() 
{
	// TODO: Add your command handler code here
	DSetupDlg Dialog;

	// ask the user for the name of the team and the server
	Dialog.m_strHandle = _T(MY_TEAM);
	Dialog.m_strServer = _T(DEFAULT_SERVER);
	Dialog.m_nChannel = DEFAULT_CHANNEL;
	Dialog.m_bGoalie = FALSE;

	// user can repeat with a different address
	while(TRUE)
	{
		if (Dialog.DoModal() != IDOK) {
			m_bTryingToConnect = FALSE;
			break;
		}
		// try to connect
		if (m_aPlayer.ConnectAgent(Dialog.m_strHandle, Dialog.m_strServer, Dialog.m_nChannel, Dialog.m_bGoalie)) 
		{ m_bTryingToConnect = TRUE; break; }
	}
	// change the view parameters of the server to the current view
//	ChangeView(m_pPerception->GetViewAngle()
}

void CPlayerDoc::OnUpdateConnect(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (m_aPlayer.IsConnected() || m_bTryingToConnect)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

void CPlayerDoc::OnDisconnect() 
{
	// TODO: Add your command handler code here
	if (!m_aPlayer.IsConnected())
		return;

	// close the socket
	m_aPlayer.DisconnectAgent();
	m_bTryingToConnect = FALSE;
}

void CPlayerDoc::OnUpdateDisconnect(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (m_aPlayer.IsConnected() || m_bTryingToConnect)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

void CPlayerDoc::OnGraphics() 
{
	// TODO: Add your command handler code here
	m_bNoGraphics = !m_bNoGraphics;
	POSITION pos = GetFirstViewPosition();
	CView *pFirstView = GetNextView( pos );
	pFirstView->Invalidate();
}


void CPlayerDoc::OnUpdateGraphics(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
		pCmdUI->SetCheck(m_bNoGraphics);
}

void CPlayerDoc::OnHear(LPCTSTR) 
{
	
}

void CPlayerDoc::OnSee() 
{
	TPerception *p = m_aPlayer.GetPerception();

	// miesto toho by malo byt MatchPlayer() - alebo uz v perception??

	// spracuj viditelnych hracov
	//   *p->m_pVisiblePlayer[]  ->  m_Players[]
	for (int i=0;i<MAX_NUM_PLAYER;i++)
	{
		if (! m_Players[i].IsValid()) continue;
		double dx = m_Players[i].GetAbsX() - p->m_pThisPlayer->GetAbsX();
		double dy = m_Players[i].GetAbsY() - p->m_pThisPlayer->GetAbsY();
		double angle;		
		if ((dx > D_ZERO_N) && (dx < D_ZERO_P))
		{
			// points are on same x coordinates
			if (dy > 0.0)	angle = 0;
			else			angle = 180;
		}
		else
		{
			angle = (int) (atan(dy / dx) * 180.0 / PI);
			if (dx < 0.0)
			{
				if (dy>0) angle = 180 + angle;
				else 	  angle = -180 + angle;
			}
		}
		angle = abs(int(angle) - p->m_pThisPlayer->GetAbsDir());
		if (angle>180) angle = 360 - angle;
		if (angle < (p->m_iViewAngle/2))
		{	
			m_Players[i].Invalidate();
		}
	}
	int cnt = 0;
	for (i=0;i<MAX_NUM_PLAYER && cnt<p->m_iNoOfPlayers;i++)
	{
		if (!m_Players[i].IsValid()) 
			m_Players[i] = *p->m_pVisiblePlayer[cnt++];
	}

	if (m_aPlayer.GetAutoPlay()) m_aPlayer.AutoPlay();
}

void CPlayerDoc::OnSenseBody() 
{
	
}
