// PlayerView.cpp : implementation of the CPlayerView class
//

#include "stdafx.h"
#include "Player.h"
#include "math.h"

#include "PlayerDoc.h"
#include "PlayerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayerView

IMPLEMENT_DYNCREATE(CPlayerView, CView)

BEGIN_MESSAGE_MAP(CPlayerView, CView)
	//{{AFX_MSG_MAP(CPlayerView)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayerView construction/destruction

CPlayerView::CPlayerView()
{
	// TODO: add construction code here

}

CPlayerView::~CPlayerView()
{
}

BOOL CPlayerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerView drawing

void CPlayerView::OnDraw(CDC* pDC)
{
	CPlayerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	pDC->SetBkColor(COLOR_BACK);
	RedrawView();

}

/////////////////////////////////////////////////////////////////////////////
// CPlayerView printing

BOOL CPlayerView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPlayerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPlayerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerView diagnostics

#ifdef _DEBUG
void CPlayerView::AssertValid() const
{
	CView::AssertValid();
}

void CPlayerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPlayerDoc* CPlayerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPlayerDoc)));
	return (CPlayerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPlayerView message handlers

void CPlayerView::RedrawView()
{
	CClientDC		pDC(this);
	CDC				dcMem;
	CBitmap			myBitmap;
	CRect			windowRect;
	int				sizeX, sizeY;
	CPen			Pen, *oldPen;
	CBrush			Brush, *oldBrush;
	CPoint			P[5];
	COLORREF			cCol;

	double	dFlagX[NO_OF_FLAGS] = FLAG_POSITIONS_X;
	double	dFlagY[NO_OF_FLAGS] = FLAG_POSITIONS_Y;

	if(GetDocument()->m_bNoGraphics) { return; }
// get Device Coordinates
	dcMem.CreateCompatibleDC(&pDC);

	
	GetClientRect(windowRect);
////	pDC.FillSolidRect(windowRect , COLOR_BACK);
//	pDC.GetWindow()->GetClientRect(&windowRect);
////	windowRect.DeflateRect(10,10,10,10);
//	windowRect.NormalizeRect();
	sizeX = windowRect.Width();
	sizeY = windowRect.Height();
	myBitmap.CreateCompatibleBitmap(&pDC, sizeX, sizeY);
	myBitmap.SetBitmapDimension(sizeX, sizeY);
	ASSERT(myBitmap.m_hObject != NULL);
	CBitmap* pOldBitmap = dcMem.SelectObject(&myBitmap);
	dcMem.FillSolidRect(0, 0, sizeX, sizeY, COLOR_BACK);

	float zoom = min(float(sizeX)/SIZE_X,float(sizeY)/SIZE_Y);
	zoom = max(2,zoom);							// do not allow zoom less than 2

	#define TX(x)	int((x)*(zoom) + sizeX/2)
	#define TY(y)	int(-(y)*(zoom) + sizeY/2)


	Pen.CreatePen(PS_SOLID,1,RGB(0,0,0));
	Brush.CreateSolidBrush(COLOR_AGENT);

	oldBrush = dcMem.SelectObject(&Brush);
	oldPen	 = dcMem.SelectObject(&Pen);
	// lines
	dcMem.FillSolidRect(CRect(TX(dFlagX[FLAG_TL]),TY(dFlagY[FLAG_TL]),
					   TX(dFlagX[FLAG_BR]),TY(dFlagY[FLAG_BR])),COLOR_FIELD);

	TPlayer * p = GetDocument()->m_aPlayer.GetPerception()->GetThisPlayer();
	int angle = GetDocument()->m_aPlayer.GetPerception()->GetViewAngle();
	if (angle<180) 
	{
		P[0].x = TX(p->GetAbsX());	P[0].y = TY(p->GetAbsY());
		P[1].x = TX(p->GetAbsX() + 200 * cos(double(p->GetAbsDir()+(angle/2))*PI/180));
		P[1].y = TY(p->GetAbsY() + 200 * sin(double(p->GetAbsDir()+(angle/2))*PI/180));
		P[2].x = TX(p->GetAbsX() + 200 * cos(double(p->GetAbsDir()-(angle/2))*PI/180));
		P[2].y = TY(p->GetAbsY() + 200 * sin(double(p->GetAbsDir()-(angle/2))*PI/180));
		dcMem.Polygon(P,3);
	}
	dcMem.SelectObject(oldPen);
	Pen.DeleteObject();
	Pen.CreatePen(PS_SOLID,2,COLOR_LINE);
	oldPen= dcMem.SelectObject(&Pen);
	//lines
	P[0].x = TX(dFlagX[FLAG_TL]);	P[0].y = TY(dFlagY[FLAG_TL]);
	P[1].x = TX(dFlagX[FLAG_BR]);	P[1].y = TY(dFlagY[FLAG_TL]);
	P[2].x = TX(dFlagX[FLAG_BR]);	P[2].y = TY(dFlagY[FLAG_BR]);
	P[3].x = TX(dFlagX[FLAG_TL]);	P[3].y = TY(dFlagY[FLAG_BR]);
	P[4] = P[0];
	dcMem.Polyline(P,5);
	// penalty area
	P[0].x = TX(dFlagX[FLAG_TL]);	P[0].y = TY(dFlagY[FLAG_PENALTY_L]);
	P[1].x = TX(dFlagX[FLAG_PENALTY_L]);	P[1].y = TY(dFlagY[FLAG_PENALTY_L]);
	P[2].x = TX(dFlagX[FLAG_PENALTY_L+2]);	P[2].y = TY(dFlagY[FLAG_PENALTY_L+2]);
	P[3].x = TX(dFlagX[FLAG_TL]);	P[3].y = TY(dFlagY[FLAG_PENALTY_L+2]);
	dcMem.Polyline(P,4);

	P[0].x = TX(dFlagX[FLAG_TR]);	P[0].y = TY(dFlagY[FLAG_PENALTY_R]);
	P[1].x = TX(dFlagX[FLAG_PENALTY_R]);	P[1].y = TY(dFlagY[FLAG_PENALTY_R]);
	P[2].x = TX(dFlagX[FLAG_PENALTY_R+2]);	P[2].y = TY(dFlagY[FLAG_PENALTY_R+2]);
	P[3].x = TX(dFlagX[FLAG_TR]);	P[3].y = TY(dFlagY[FLAG_PENALTY_R+2]);
	dcMem.Polyline(P,4);

	// goals area
	P[0].x = TX(dFlagX[GOAL_POST_L+1]);	P[0].y = TY(dFlagY[GOAL_POST_L+1]-2);
	P[1].x = TX(dFlagX[GOAL_POST_L]+5);	P[1].y = TY(dFlagY[GOAL_POST_L+1]-2);
	P[2].x = TX(dFlagX[GOAL_POST_L]+5);	P[2].y = TY(dFlagY[GOAL_POST_L]+2);
	P[3].x = TX(dFlagX[GOAL_POST_L+1]);	P[3].y = TY(dFlagY[GOAL_POST_L]+2);
	dcMem.Polyline(P,4);

	P[0].x = TX(dFlagX[GOAL_POST_R+1]);	P[0].y = TY(dFlagY[GOAL_POST_R+1]-2);
	P[1].x = TX(dFlagX[GOAL_POST_R]-5);	P[1].y = TY(dFlagY[GOAL_POST_R+1]-2);
	P[2].x = TX(dFlagX[GOAL_POST_R]-5);	P[2].y = TY(dFlagY[GOAL_POST_R]+2);
	P[3].x = TX(dFlagX[GOAL_POST_R+1]);	P[3].y = TY(dFlagY[GOAL_POST_R]+2);
	dcMem.Polyline(P,4);

/*	dcMem.Rectangle(CRect(TX(dFlagX[GOAL_POST_L+1]),TY(dFlagY[GOAL_POST_L+1]+2),
					    TX(dFlagX[GOAL_POST_L]+5),TY(dFlagY[GOAL_POST_L]-2)));*/
	// goals
	dcMem.FillSolidRect(CRect(TX(dFlagX[GOAL_POST_L+1])-2,TY(dFlagY[GOAL_POST_L+1]),
					    TX(dFlagX[GOAL_POST_L])+2,TY(dFlagY[GOAL_POST_L])),COLOR_GOAL);
	dcMem.FillSolidRect(CRect(TX(dFlagX[GOAL_POST_R+1])-2,TY(dFlagY[GOAL_POST_R+1]),
					    TX(dFlagX[GOAL_POST_R])+2,TY(dFlagY[GOAL_POST_R])),COLOR_GOAL);
	dcMem.SetBkColor(COLOR_BACK);



	// rings
	dcMem.Arc(TX(dFlagX[GOAL_L]+11-9),TY(+9),
			TX(dFlagX[GOAL_L]+11+9),TY(-9),
			TX(dFlagX[FLAG_PENALTY_L+1]),TY(dFlagY[FLAG_PENALTY_L+1]-7),
			TX(dFlagX[FLAG_PENALTY_L+1]),TY(dFlagY[FLAG_PENALTY_L+1]+7));
	dcMem.Arc(TX(dFlagX[GOAL_R]-11-9),TY(+9),
			TX(dFlagX[GOAL_R]-11+9),TY(-9),
			TX(dFlagX[FLAG_PENALTY_R+1]),TY(dFlagY[FLAG_PENALTY_R+1]+7),
			TX(dFlagX[FLAG_PENALTY_R+1]),TY(dFlagY[FLAG_PENALTY_R+1]-7));
	dcMem.Arc(TX(-9),TY(9),TX(9),TY(-9),TX(0),TY(0),TX(0),TY(0));

	// center line
	P[0].x = TX(dFlagX[CENTER_TOP]);	P[0].y = TY(dFlagY[CENTER_TOP]);
	P[1].x = TX(dFlagX[CENTER_BOTTOM]);	P[1].y = TY(dFlagY[CENTER_BOTTOM]);
	dcMem.Polyline(P,2);

	// 11
	P[0].x = TX(dFlagX[GOAL_L]+11);	P[0].y = TY(0)-1;
	P[1].x = TX(dFlagX[GOAL_L]+11);	P[1].y = TY(0)+1;
	dcMem.Polyline(P,2);

	P[0].x = TX(dFlagX[GOAL_R]-11);	P[0].y = TY(0)-1;
	P[1].x = TX(dFlagX[GOAL_R]-11);	P[1].y = TY(0)+1;
	dcMem.Polyline(P,2);

	dcMem.SelectObject(oldPen);
	Pen.DeleteObject();
	Pen.CreatePen(PS_SOLID,2,COLOR_FLAG);
	oldPen = dcMem.SelectObject(&Pen);

	TPerception *per=GetDocument()->m_aPlayer.GetPerception();

	//CString f;
	for(int i=0;i<NO_OF_FLAGS-1;i++) {
			/*f.Format("%d",i);
			pDC.TextOut(TX(dFlagX[i]),
						TY(dFlagY[i]),
						CString(f));*/
			cCol = COLOR_GOAL;
if ((i == per->mm_iFlag1) || (i == per->mm_iFlag2)) cCol = COLOR_BALL;

			dcMem.FillSolidRect(CRect(TX(dFlagX[i])-4,TY(dFlagY[i])-4,
					    TX(dFlagX[i])+4
						,TY(dFlagY[i])+4), cCol);

			P[0].x = TX(dFlagX[i])-2;	P[0].y = TY(dFlagY[i]);
			P[1].x = TX(dFlagX[i])+2;	P[1].y = TY(dFlagY[i]);
			dcMem.Polyline(P,2);

			P[0].x = TX(dFlagX[i]);	P[0].y = TY(dFlagY[i])-2;
			P[1].x = TX(dFlagX[i]);	P[1].y = TY(dFlagY[i])+2;
			dcMem.Polyline(P,2);
			}
	dcMem.SelectObject(oldPen);
	Pen.DeleteObject();
	Pen.CreatePen(PS_SOLID,2,RGB(255,0,0));
	oldPen = dcMem.SelectObject(&Pen);

	for (i = 0; i < NO_OF_FLAGS; i++)
	{
		if (per->m_pFlag[i]->IsValid())
		{
			int dir = p->GetAbsDir() - per->m_pFlag[i]->GetDirection();
			P[3].x = TX(per->m_pFlag[i]->GetDistance() * cos(dir* PI/180) + p->GetAbsX());
			P[3].y = TY(per->m_pFlag[i]->GetDistance() * sin(dir* PI/180) + p->GetAbsY());
			P[0].x = P[3].x-2;	P[0].y = P[3].y;
			P[1].x = P[3].x+2;	P[1].y = P[3].y;
			dcMem.Polyline(P,2);

			P[0].x = P[3].x;	P[0].y = P[3].y-2;
			P[1].x = P[3].x;	P[1].y = P[3].y+2;
			dcMem.Polyline(P,2);
		}
	}

	dcMem.SelectObject(oldBrush);
	dcMem.SelectObject(oldPen);
	Brush.DeleteObject();
	Pen.DeleteObject();
	CPlayerDoc *doc = GetDocument();
	for (i=0; i<MAX_NUM_PLAYER && doc->m_Players[i].IsValid();i++)
	{
		int team = doc->m_Players[i].GetTeam();
		if (team == 0)
			cCol = COLOR_MYTEAM;
		else if (team == 1)
			cCol = COLOR_OTHERTEAM;
/*		else if (team == -1)
			cCol = COLOR_AGENT;*/
		else
			cCol = COLOR_ANY_OBJECT;
		
		Brush.CreateSolidBrush(cCol);
		oldBrush = dcMem.SelectObject(&Brush);
		double x = doc->m_Players[i].GetAbsX();
		double y = doc->m_Players[i].GetAbsY();
		int facedir = doc->m_Players[i].GetAbsDir();
		dcMem.Ellipse(TX(x-1),TY(y-1),TX(x+1),TY(y+1));
		if (doc->m_Players[i].GetFaceDir() != NOT_EXISTING)
		{
			P[0].x = TX(x);	P[0].y = TY(y);
			P[1].x = TX(x + 2*cos(facedir * PI/180));
			P[1].y = TY(y + 2*sin(facedir * PI/180));
			dcMem.Polyline(P,2);
		}
		dcMem.SelectObject(oldBrush);
		Brush.DeleteObject();
	}

	// nakresli lobtu
	if (per->GetBall()->IsValid())  cCol = COLOR_BALL;
	else							cCol = COLOR_ANY_OBJECT;
	Brush.CreateSolidBrush(cCol);
	oldBrush = dcMem.SelectObject(&Brush);
	double x = per->GetBall()->GetAbsX();
	double y = per->GetBall()->GetAbsY();	
	dcMem.Ellipse(TX(x-1),TY(y-1),TX(x+1),TY(y+1));	
	dcMem.SelectObject(oldBrush);
	Brush.DeleteObject();

	// predpokladane pozicie lopty
	Brush.CreateSolidBrush(cCol);
	oldBrush = dcMem.SelectObject(&Brush);
	for(i=0; i<MAX_FUTURE_POSITIONS; i++) {
		double x = per->GetFutureBallPosition(i)->GetX();
		double y = per->GetFutureBallPosition(i)->GetY();
		dcMem.Ellipse(TX(x-0.3),TY(y-0.3),TX(x+0.3),TY(y+0.3));	
	}
	dcMem.SelectObject(oldBrush);
	Brush.DeleteObject();

	Brush.CreateSolidBrush(COLOR_LINE);
	oldBrush = dcMem.SelectObject(&Brush);
	x = per->mm_x2;
	y = per->mm_y2;
	dcMem.Ellipse(TX(x-0.7),TY(y-0.7),TX(x+0.7),TY(y+0.7));	
	dcMem.SelectObject(oldBrush);
	Brush.DeleteObject();


/*	// branky

	Brush.CreateSolidBrush(cCol);
	oldBrush = dcMem.SelectObject(&Brush);
	x = per->m_pGoal[0]->GetAbsX();
	y = per->m_pGoal[0]->GetAbsY();	
	dcMem.Ellipse(TX(x-1),TY(y-1),TX(x+1),TY(y+1));	
	dcMem.SelectObject(oldBrush);
	Brush.DeleteObject();

	Brush.CreateSolidBrush(cCol);
	oldBrush = dcMem.SelectObject(&Brush);
	x = per->m_pGoal[1]->GetAbsX();
	y = per->m_pGoal[1]->GetAbsY();	
	dcMem.Ellipse(TX(x-1),TY(y-1),TX(x+1),TY(y+1));	
	dcMem.SelectObject(oldBrush);
	Brush.DeleteObject();
*/

//  draw a Ellipse at the players position

//	dcMem.SetPixel(TX(p->GetAbsX()),TY(p->GetAbsY()),COLOR_LINE);
//	dcMem.AngleArc
	/*dcMem.SetBkColor(COLOR_BACK);
	CString f;

	f.Format("%d",p->GetAbsDir());
	dcMem.DrawText(f,CRect(10,10,50,25),DT_CENTER);
*/

	// copy the memory bitmap into the window
	pDC.BitBlt(0, 0, sizeX, sizeY, &dcMem, 0, 0, SRCCOPY);
	// remove the created bitmap
	dcMem.SelectObject(pOldBitmap);
	dcMem.DeleteDC();
	myBitmap.DeleteObject();

}

/*
	#define NO_OF_FLAGS		50
#define CENTER_MARK		0
#define CENTER_TOP		1
#define 	2
#define GOAL_POST_L		3
#define GOAL_POST_R		5
#define FLAG_OUTSIDE_TL	7
#define FLAG_OUTSIDE_TC	12
#define FLAG_OUTSIDE_TR	13
#define FLAG_OUTSIDE_BL	18
#define FLAG_OUTSIDE_BC	23
#define FLAG_OUTSIDE_BR	24
#define FLAG_OUTSIDE_LT	29
#define FLAG_OUTSIDE_LC	32
#define FLAG_OUTSIDE_LB	33
#define FLAG_OUTSIDE_RT	36
#define FLAG_OUTSIDE_RC	39
#define FLAG_OUTSIDE_RB	40
#define FLAG_PENALTY_L	43
#define FLAG_PENALTY_R	46
#define TRASH_FLAG		49

#define FLAG_POSITIONS_X { 0.0, 0.0, 0.0, -52.5, -52.5, 52.5, 52.5\
				, -10.0, -20.0, -30.0, -40.0, -50.0, 0.0\
				, 10.0, 20.0, 30.0, 40.0, 50.0\
				, -10.0, -20.0, -30.0, -40.0, -50.0, 0.0\
				, 10.0, 20.0, 30.0, 40.0, 50.0\
				, -57.5, -57.5, -57.5, -57.5\
				, -57.5, -57.5, -57.5\
				, 57.5, 57.5, 57.5, 57.5\
				, 57.5, 57.5, 57.5\

//	pDC.Ellipse(CRect(-500,-500,500,500));*/

//	cCol = COLOR_FIELD;
///	brush.CreateSolidBrush(cCol);
//	oldBrush = dcMem.SelectObject(&brush);

//	dcMem.SelectObject(oldBrush);
//	brush.DeleteObject();

//	if (m_pScreen->IsTopView())
//		m_pScreen->SetMid(sizeX / 2, sizeY - 30);
//	else
//		m_pScreen->SetMid(sizeX / 2, sizeY / 2);
//	m_pPerception->DrawPerception(&dcMem, m_pScreen);

	// copy the memory bitmap into the window
/*	pDC.BitBlt(0, 0, sizeX, sizeY, &dcMem, 0, 0, SRCCOPY);

	// remove the created bitmap
	dcMem.SelectObject(pOldBitmap);
	dcMem.DeleteDC();
	myBitmap.DeleteObject();/*/
//}


void CPlayerView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	// switch on the command received
	switch (nChar)
	{
		case '1':
			GetDocument()->m_aPlayer.SetAutoPlay(1);
			break;
		case '2':
			GetDocument()->m_aPlayer.SetAutoPlay(2);
			break;
		case '3':
			GetDocument()->m_aPlayer.SetAutoPlay(3);
			break;
		case '4':
			GetDocument()->m_aPlayer.SetAutoPlay(4);
			break;
		case '0':
			GetDocument()->m_aPlayer.SetAutoPlay(FALSE);
			break;

		case ' ':
			GetDocument()->m_aPlayer.Kick(100, 0);
			break;
        case 'q':
			GetDocument()->m_aPlayer.Kick(GetDocument()->m_aPlayer.GetPerception()->m_pThisPlayer->GetAbsDir(), 0);
			break;
		case 'j':
			GetDocument()->m_aPlayer.Turn(-15);
			break;
		case 'l':
			GetDocument()->m_aPlayer.Turn(15);
			break;
		case 'i':
			GetDocument()->m_aPlayer.Dash(30);
			break;
		case 'k':
			GetDocument()->m_aPlayer.Dash(-30);
			break;

		case VK_RETURN:
			GetDocument()->m_aPlayer.Move(-5, 0);
			break;

		case 's':
			GetDocument()->m_aPlayer.SenseBody();	
			break;

		default:
			CView::OnChar(nChar, nRepCnt, nFlags);
	}
}

void CPlayerView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	
}

void CPlayerView::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	// TODO: Add your specialized code here and/or call the base class
	RedrawView();
	CView::CalcWindowRect(lpClientRect, nAdjustType);
}
