#include "PlayerDoc.h"

class CBaseModule : public CObject
{
public:
	CBaseModule();
	CPlayerDoc* doc;	
	void SetDoc(CPlayerDoc* a) { doc = a;}

// agents outgoing commands
	void Kick(int power,int direction) { doc->m_aPlayer.Kick(power,direction); }
	void Move(int x,int y) { doc->m_aPlayer.Move(x,y); }
	void Dash(int power) { doc->m_aPlayer.Dash(power); }
	void Turn(int moment) { doc->m_aPlayer.Turn(moment); }
	void Say(CString s) { doc->m_aPlayer.Say(s); }
	void ChangeView(int width,int quality) { doc->m_aPlayer.ChangeView(width,quality); } // 45-90-180 0-1
// agents info function
	int GetSide() { return doc->m_aPlayer.m_pPerception.GetSide(); } // RIGHT_TO_LEFT - LEFT_TO_RIGHT
	int GetNumber() { return doc->m_aPlayer.m_pPerception.GetNumber(); }
	int GetPlayMode() { return doc->m_aPlayer.m_pPerception.GetPlayMode(); } // BEFORE_KICK_OFF ....

// asynchronous messages
	virtual void OnSee()						=0;
	virtual void OnHearReferre(CString msg)		=0;
	virtual void OnHearSelf(CString msg)		=0;
	virtual void OnHearMessage(CString msg)		=0;
	virtual void OnSenseBody(int m_iSenseTime, int m_iViewQuality, int m_iViewAngle,
							int m_iStamina, int m_iSpeed, int m_iNoOfKick,
							int m_iNoOfDash, int m_iNoOfTurn, int m_iNoOfSay) =0;
//  module interface
	virtual float Avaliability()				=0;
	
};
